package apps

import (
	"github.com/zeromicro/go-zero/rest/httpx"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/logic/apps"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/svc"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/types"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/pkg/repository/result"
	"net/http"
)

func PauseAppByAppNameHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.DeleteAppReq
		if err := httpx.Parse(r, &req); err != nil {
			result.ParamErrorResult(r, w, err)
			return
		}

		l := apps.NewPauseAppByAppNameLogic(r.Context(), svcCtx)
		resp, err := l.PauseAppByAppName(&req)
		result.HttpResult(r, w, resp, err)
	}
}
