package cloud

import (
	"github.com/zeromicro/go-zero/rest/httpx"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/logic/cloud"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/svc"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/api/internal/types"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/pkg/repository/result"
	"net/http"
)

func ListCloudClusterHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.ListClusterReq
		if err := httpx.Parse(r, &req); err != nil {
			result.ParamErrorResult(r, w, err)
			return
		}

		l := cloud.NewListCloudClusterLogic(r.Context(), svcCtx)
		resp, err := l.ListCloudCluster(&req)
		result.HttpResult(r, w, resp, err)
	}
}
