/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package models

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AiCenterModel = (*customAiCenterModel)(nil)

type (
	// AiCenterModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAiCenterModel.
	AiCenterModel interface {
		aiCenterModel
	}

	customAiCenterModel struct {
		*defaultAiCenterModel
	}
)

// NewAiCenterModel returns a models for the database table.
func NewAiCenterModel(conn sqlx.SqlConn, c cache.CacheConf) AiCenterModel {
	return &customAiCenterModel{
		defaultAiCenterModel: newAiCenterModel(conn, c),
	}
}
