/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package models

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ DictModel = (*customDictModel)(nil)

type (
	// DictModel is an interface to be customized, add more methods here,
	// and implement the added methods in customDictModel.
	DictModel interface {
		dictModel
	}

	customDictModel struct {
		*defaultDictModel
	}
)

// NewDictModel returns a models for the database table.
func NewDictModel(conn sqlx.SqlConn, c cache.CacheConf) DictModel {
	return &customDictModel{
		defaultDictModel: newDictModel(conn, c),
	}
}
