/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package models

import "time"

// DataSet  。
// 说明:
// 表名:data_set
// group: DataSet
// obsolete:
// appliesto:go 1.8+;
// namespace:hongmouer.his.models.DataSet
// assembly: hongmouer.his.models.go
// class:HongMouer.HIS.Models.DataSet
// version:2023-05-06 09:58
type File struct {
	Id          *int       `gorm:"column:id" json:"Id"`     //type:*int         comment:id          version:2023-05-06 09:58
	Name        string     `gorm:"column:name" json:"Name"` //type:string       comment:文件名称    version:2023-05-06 09:58
	Kind        string     `gorm:"column:kind" json:"Kind"`
	DataType    string     `gorm:"column:data_type" json:"dataType"`       //type:string       comment:            version:2023-05-06 09:58
	Suffix      string     `gorm:"column:suffix" json:"Suffix"`            //type:string       comment:后缀名      version:2023-05-06 09:58
	Bucket      string     `gorm:"column:bucket" json:"Bucket"`            //type:string       comment:桶          version:2023-05-06 09:58
	Hash        string     `gorm:"column:hash" json:"Hash"`                //type:string       comment:hash          version:2023-05-06 09:58
	Status      string     `gorm:"column:status" json:"Status"`            //type:string       comment:hash          version:2023-05-06 09:58
	DeletedFlag *int       `gorm:"column:deleted_flag" json:"DeletedFlag"` //type:*int         comment:是否删除    version:2023-05-06 09:58
	CreatedBy   *int       `gorm:"column:created_by" json:"CreatedBy"`     //type:*int         comment:创建人      version:2023-05-06 09:58
	CreatedTime *time.Time `gorm:"column:created_time" json:"CreatedTime"` //type:*time.Time   comment:创建时间    version:2023-05-06 09:58
	UpdatedBy   *int       `gorm:"column:updated_by" json:"UpdatedBy"`     //type:*int         comment:更新人      version:2023-05-06 09:58
	UpdatedTime *time.Time `gorm:"column:updated_time" json:"UpdatedTime"` //type:*time.Time   comment:更新时间    version:2023-05-06 09:58
}

// TableName 表名:data_set，。
// 说明:
func TableName() string {
	return "t_file"
}
