/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package participantservicelogic

import (
	"context"
	"github.com/zeromicro/go-zero/core/logx"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/pkg/models"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/rpc/internal/svc"
	"gitlink.org.cn/jcce-pcm/pcm-coordinator/rpc/pcmCore"
)

type ListPhyAvailableLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewListPhyAvailableLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListPhyAvailableLogic {
	return &ListPhyAvailableLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// listAvailable 集群动态信息列表
func (l *ListPhyAvailableLogic) ListPhyAvailable(in *pcmCore.ParticipantTenant) (*pcmCore.ListParticipantAvailResp, error) {
	// todo: add your logic here and delete this line
	resp := &pcmCore.ListParticipantAvailResp{}
	var scParticipantPhyInfoS []models.ScParticipantAvailInfo
	//查询集群静态信息列表
	l.svcCtx.DbEngin.Find(&scParticipantPhyInfoS)
	utils.Convert(scParticipantPhyInfoS, &resp.ParticipantAvails)
	return resp, nil
}
